#include <Wire.h> 
#define SER_Pin   2   //Serial data input
#define LAT_Pin  3   //Latch
#define SRCLK_Pin 4   //Shift register clock
int lastDig=0;
int lastUpd=0;
//Initialisation
byte buf[5]={0,0,0,0,0};
int digit=0;

static byte digits[5] = { 
                    0xFE,  //digit 1 from left
                    0xFD,  //digit 2 from left
                    0xFB,  //digit 3 from left
                    0xF7,  //digit 4 from left
                    0xEF,  //digit 5 from left
                    };
static byte segments[13] = {
                    0b00111111,  // 0
                    0b00000110,  // 1
                    0b01011011,  // 2
                    0b01001111,  // 3
                    0b01100110,  // 4
                    0b01101101,  // 5
                    0b01111101,  // 6
                    0b00000111,  // 7
                    0b01111111,  // 8
                    0b01101111,  // 9  
                    0b10000000,  //dot
                    0b01000000,  // -                  
                    0b00000000   //blank
                    };     


void writeShift(byte segments,byte digit){
  digitalWrite(LAT_Pin,LOW);
  shiftOut(SER_Pin, SRCLK_Pin, MSBFIRST, digit); 
  shiftOut(SER_Pin, SRCLK_Pin, MSBFIRST, segments);
  digitalWrite(LAT_Pin,HIGH);  
}
void setup(){
  pinMode(SER_Pin, OUTPUT);
  pinMode(LAT_Pin, OUTPUT);  
  pinMode(SRCLK_Pin, OUTPUT); 
  writeShift(0,0);
 
  }
void updateDigits(int num){
    buf[4]=num%10;
    buf[3]=(num/10)%10;
    buf[2]=(num/100)%10;
    buf[1]=(num/1000)%10;
    buf[0]=(num/10000)%10;
  }
  
void loop(){
  //update
  int time=millis();
  if(time-lastDig > 1){
      lastDig=time;
      writeShift(segments[buf[digit]],digits[digit]);
      digit=++digit%5;
  }
 
  if(time-lastUpd>20){
    lastUpd=time;
    updateDigits(analogRead(0));
    }
    

}

